<?php

/*

This file handles all initial setup of the plugin via 

*/

		
global $wpmt_db_version;
$wpmt_db_version = "1.1";

function wpmt_install($upgrade='') {
	
   global $wpdb;
   global $wpmt_db_version;

	if(WPMT_DB_PREFIX=='get_the_table_prefix') {$table_prefix = $wpdb->prefix; } else {$table_prefix = WPMT_DB_PREFIX;}
  
  //wpmt Data structure
  $sql = "CREATE TABLE ".$table_prefix."wpmt_visitors (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		filtered tinyint(1) NOT NULL,
		time_created datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		cookie VARCHAR(10) DEFAULT '' NOT NULL,
		ip_address VARCHAR(24) DEFAULT '' NOT NULL,
		user_agent VARCHAR(255) DEFAULT '' NOT NULL,
		browser VARCHAR(32) DEFAULT '' NOT NULL,
		operating_system VARCHAR(32) DEFAULT '' NOT NULL,
		referal_url VARCHAR(255) DEFAULT '' NOT NULL,
		country_code VARCHAR(2) DEFAULT '' NOT NULL,
		country_name VARCHAR(64) DEFAULT '' NOT NULL,
		region_code VARCHAR(12) DEFAULT '' NOT NULL,
		region_name VARCHAR(128) DEFAULT '' NOT NULL,
		zipcode VARCHAR(16) DEFAULT '' NOT NULL,
		latitude DECIMAL(7,4) NOT NULL,
		longitude DECIMAL(7,4) NOT NULL,
		UNIQUE KEY id (id),
		UNIQUE KEY cookie (cookie) 
		  );		  
		  
		
		CREATE TABLE ".$table_prefix."wpmt_impressions (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		text_id VARCHAR(7) DEFAULT '' NOT NULL,
		filtered tinyint(1) NOT NULL,
		wpmt_visitor_id mediumint(9) NOT NULL, 
		time_created datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		ip_address VARCHAR(24) DEFAULT '' NOT NULL,
		impression_url VARCHAR(255) DEFAULT '' NOT NULL,
		referal_url VARCHAR(255) DEFAULT '' NOT NULL,
		load_time mediumint(7) NOT NULL,
		UNIQUE KEY id (id),
		UNIQUE KEY text_id (text_id),
		FOREIGN KEY (wpmt_visitor_id) REFERENCES ".$table_prefix."wpmt_visitors(id)
		  );
		  
		  
		CREATE TABLE ".$table_prefix."wpmt_data (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		wpmt_visitor_id mediumint(9) NOT NULL, 
		wpmt_impression_id mediumint(9) NOT NULL, 
		time_created datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		mouse_coords TEXT DEFAULT '' NOT NULL,
		window_size TEXT DEFAULT '' NOT NULL,
		scroll_top TEXT DEFAULT '' NOT NULL,
		click_coords TEXT DEFAULT '' NOT NULL,
		html_clicks TEXT DEFAULT '' NOT NULL,
		UNIQUE KEY id (id),
		FOREIGN KEY (wpmt_visitor_id) REFERENCES ".$table_prefix."wpmt_visitors(id),
		FOREIGN KEY (wpmt_impression_id) REFERENCES ".$table_prefix."wpmt_impressions(id)
		  );	
		  
		  CREATE TABLE ".$table_prefix."wpmt_click_filter (
		id mediumint(9) NOT NULL AUTO_INCREMENT, 
		time_created datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		ip_address VARCHAR(24) DEFAULT '' NOT NULL,
		user_agent VARCHAR(255) DEFAULT '' NOT NULL,
		note VARCHAR(255) DEFAULT '' NOT NULL,
		UNIQUE KEY id (id)
		  );
		  
		  CREATE TABLE ".$table_prefix."wpmt_settings (
		id mediumint(9) NOT NULL AUTO_INCREMENT, 
		name VARCHAR(64) DEFAULT '' NOT NULL,
		value TEXT DEFAULT '' NOT NULL,
		wp_user_id mediumint(9) NOT NULL, 
		UNIQUE KEY id (id)
		  );
		  		  
		CREATE TABLE ".$table_prefix."wpmt_live_visitors (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		filtered tinyint(1) NOT NULL,
		wpmt_visitor_id mediumint(9) NOT NULL, 
		wpmt_impression_id mediumint(9) NOT NULL, 
		time_created datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		time_last_impression datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		impressions mediumint(7) NOT NULL,
		last_impression_url TEXT DEFAULT '' NOT NULL,
		UNIQUE KEY id (id),
		FOREIGN KEY (wpmt_visitor_id) REFERENCES ".$table_prefix."wpmt_visitors(id),
		FOREIGN KEY (wpmt_impression_id) REFERENCES ".$table_prefix."wpmt_impressions(id)
		  );	
		  
		  ";

   require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
   dbDelta($sql);


   if($upgrade!=1) {
   
	   $user_agents = array('Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)','Mozilla/5.0 (compatible; bingbot/2.0; +http://www.bing.com/bingbot.htm)','Mozilla/5.0 (compatible; Baiduspider/2.0; +http://www.baidu.com/search/spider.html)','Mozilla/5.0 (compatible; YandexBot/3.0; +http://yandex.com/bots)','Mozilla/5.0 (compatible; YandexImages/3.0; +http://yandex.com/bots)','Mozilla/5.0 (compatible; YandexBot/3.0; MirrorDetector; +http://yandex.com/bots)','msnbot-media/1.1 (+http://search.msn.com/msnbot.htm)','Mozilla/5.0 (compatible; AhrefsBot/4.0; +http://ahrefs.com/robot/)','DoCoMo/2.0 N905i(c100;TB;W24H16) (compatible; Googlebot-Mobile/2.1; +http://www.google.com/bot.html)');
	   
	   foreach($user_agents as $key => $value) {
	   
	   unset($data);
		$data = array(
			'id' => NULL,
			'time_created' => current_time('mysql', 1),
			'user_agent' => $value
		);
		
		$wpdb->insert($table_prefix."wpmt_click_filter", $data );
		
	   }
 
   }
 
   add_option("wpmt_db_version", $wpmt_db_version);
   
}


function wpmt_uninstall() {
	
   global $wpdb;
   global $wpmt_db_version;
   
  $wpdb->query("DROP TABLE ".WPMT_DB_PREFIX."wpmt_settings");
  
  //Delete wpmt Tables
  /*
  */
  
}
        
        ?>