<?php

/*
Plugin Name: Don's WP Real Time Mouse Tracker
Plugin URI: http://www.donswprmt.com
Description: Don's WP RMT tracks every single move and click a visitor makes on your site. You can then play these back in a myriad of ways to optimize your site to make more money!
Version: 1.0.1
Author: Don Westendorp - Quality Internet Services LLC
Author URI: http://www.donswprmt.com
License: Don's WP RMT End User License Agreement
*/

/*  Copyright 2013  Quality Internet Services LLC  (email : admin@qualityinternetservicesllc.com)

END USER LICENSE AGREEMENT

This copy of Don's WP Real Time Mouse Tracker ("the Software Product") and accompanying documentation is licensed and not sold. This Software Product is protected by copyright laws and treaties, as well as laws and treaties related to other forms of intellectual property. Quality Internet Services LLC or its subsidiaries, affiliates, and suppliers (collectively "Quality Internet Services") own intellectual property rights in the Software Product. The Licensee's ("you" or "your") license to download, use, copy, or change the Software Product is subject to these rights and to all the terms and conditions of this End User License Agreement ("Agreement").

Acceptance
YOU ACCEPT AND AGREE TO BE BOUND BY THE TERMS OF THIS AGREEMENT BY SELECTING THE "ACCEPT" OPTION AND DOWNLOADING THE SOFTWARE PRODUCT OR BY INSTALLING, USING, OR COPYING THE SOFTWARE PRODUCT. YOU MUST AGREE TO ALL OF THE TERMS OF THIS AGREEMENT BEFORE YOU WILL BE ALLOWED TO DOWNLOAD THE SOFTWARE PRODUCT. IF YOU DO NOT AGREE TO ALL OF THE TERMS OF THIS AGREEMENT, YOU MUST SELECT "DECLINE" AND YOU MUST NOT INSTALL, USE, OR COPY THE SOFTWARE PRODUCT.

License Grant
This Agreement entitles you to install and use unliimited copies of the Software Product on web domains that you own. In addition, you may make one archival copy of the Software Product. The archival copy must be on a storage medium other than a hard drive, and may only be used for the reinstallation of the Software Product.  Multiple copy use or installation is only allowed on web sites and web domains that you own. If you wish to install this software on to a web site owned by another person or business you must obtain a license for them on an individual basis.

Restrictions on Transfer
Without first obtaining the express written consent of Quality Internet Services, you may not assign your rights and obligations under this Agreement, or redistribute, encumber, sell, rent, lease, sublicense, or otherwise transfer your rights to the Software Product.

Restrictions on Alteration
You may not create any derivative work of the Software Product or its accompanying documentation. Derivative works include but are not limited to translations. You may modify the software to suit your own personal needs, but you may not redistribute these changes without written consent from Quality Internet Services.

Restrictions on Copying
You may not copy any part of the Software Product except to the extent that licensed use inherently demands the creation of a temporary copy stored in computer memory and not permanently affixed on storage medium. You may make one archival copy which must be stored on a medium other than a computer hard drive.

Limited Software Product Warranty
For a period of 45 days from the date of shipment or from the date that you download the Software Product, as applicable, Quality Internet Services warrants that when properly installed and used under normal conditions, the Software Product will perform substantially as advertised.

Disclaimer of Warranties and Limitation of Liability
UNLESS OTHERWISE EXPLICITLY AGREED TO IN WRITING BY QUALITY INTERNET SERVICES, QUALITY INTERNET SERVICES MAKES NO OTHER WARRANTIES, EXPRESS OR IMPLIED, IN FACT OR IN LAW, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OTHER THAN AS SET FORTH IN THIS AGREEMENT OR IN THE LIMITED WARRANTY DOCUMENTS PROVIDED WITH THE SOFTWARE PRODUCT.

Quality Internet Services makes no warranty that the Software Product will meet your requirements or operate under your specific conditions of use. Quality Internet Services makes no warranty that operation of the Software Product will be secure, error free, or free from interruption. YOU MUST DETERMINE WHETHER THE SOFTWARE PRODUCT SUFFICIENTLY MEETS YOUR REQUIREMENTS FOR SECURITY AND UNINTERRUPTABILITY. YOU BEAR SOLE RESPONSIBILITY AND ALL LIABILITY FOR ANY LOSS INCURRED DUE TO FAILURE OF THE SOFTWARE PRODUCT TO MEET YOUR REQUIREMENTS. QUALITY INTERNET SERVICES WILL NOT, UNDER ANY CIRCUMSTANCES, BE RESPONSIBLE OR LIABLE FOR THE LOSS OF DATA ON ANY COMPUTER OR INFORMATION STORAGE DEVICE.

UNDER NO CIRCUMSTANCES SHALL QUALITY INTERNET SERVICES, ITS DIRECTORS, OFFICERS, EMPLOYEES OR AGENTS BE LIABLE TO YOU OR ANY OTHER PARTY FOR INDIRECT, CONSEQUENTIAL, SPECIAL, INCIDENTAL, PUNITIVE, OR EXEMPLARY DAMAGES OF ANY KIND (INCLUDING LOST REVENUES OR PROFITS OR LOSS OF BUSINESS) RESULTING FROM THIS AGREEMENT, OR FROM THE FURNISHING, PERFORMANCE, INSTALLATION, OR USE OF THE SOFTWARE PRODUCT, WHETHER DUE TO A BREACH OF CONTRACT, BREACH OF WARRANTY, OR THE NEGLIGENCE OF QUALITY INTERNET SERVICES OR ANY OTHER PARTY, EVEN IF QUALITY INTERNET SERVICES IS ADVISED BEFOREHAND OF THE POSSIBILITY OF SUCH DAMAGES. TO THE EXTENT THAT THE APPLICABLE JURISDICTION LIMITS QUALITY INTERNET SERVICES'S ABILITY TO DISCLAIM ANY IMPLIED WARRANTIES, THIS DISCLAIMER SHALL BE EFFECTIVE TO THE MAXIMUM EXTENT PERMITTED.

Limitation of Remedies and Damages
Your remedy for a breach of this Agreement or of any warranty included in this Agreement is the correction or replacement of the Software Product. Selection of whether to correct or replace shall be solely at the discretion of Quality Internet Services. Quality Internet Services reserves the right to substitute a functionally equivalent copy of the Software Product as a replacement. If Quality Internet Services is unable to provide a replacement or substitute Software Product or corrections to the Software Product, your sole alternate remedy shall be a refund of the purchase price for the Software Product exclusive of any costs for shipping and handling.

Any claim must be made within the applicable warranty period. All warranties cover only defects arising under normal use and do not include malfunctions or failure resulting from misuse, abuse, neglect, alteration, problems with electrical power, acts of nature, unusual temperatures or humidity, improper installation, or damage determined by Quality Internet Services to have been caused by you. All limited warranties on the Software Product are granted only to you and are non-transferable. You agree to indemnify and hold Quality Internet Services harmless from all claims, judgments, liabilities, expenses, or costs arising from your breach of this Agreement and/or acts or omissions.

Governing Law, Jurisdiction and Costs
This Agreement is governed by the laws of Minnesota, without regard to Minnesota's conflict or choice of law provisions.

Severability
If any provision of this Agreement shall be held to be invalid or unenforceable, the remainder of this Agreement shall remain in full force and effect. To the extent any express or implied restrictions are not permitted by applicable laws, these express or implied restrictions shall remain in force and effect to the maximum extent permitted by such applicable laws.
*/


/*

IMPORTANT CONSTANTS
Use these to change things about this plugin if you know what you're doing

*/

/*------------------------------------------------------

MAXIMUM MOUSE RECORDING TIME IN MINUTES
Any recordings longer than this will be automatically terminated.

--------------------------------------------------------*/

define('WPMT_MAX_RECORDING_LENGTH', 20);

/*------------------------------------------------------

DISABLE GEOCODING SERVICE
This can improve performance if your page load times are slow.
Set to 0 to disable and 1 to enable

--------------------------------------------------------*/

define('WPMT_GEOCODING', 1);



/*----------------------------------------------------


DB PREFIX OVERRIDE FOR MULTIPLE BLOGS
If you want to run this plugin on multiple blogs that have tables 
IN THE SAME DATABASE with DIFFERENT prefixes change this constant
from '$wpdb->prefix' to a prefix ('example_') of your choosing.
This cannot be a BLANK value ('')


-----------------------------------------------------*/


$WPMT_DATABASE_PREFIX_OVERRIDE = $wpdb->prefix;


/*-------------------------------------------------------*/


//Currency abbreviation and symbol
define('WPMT_CURRENCY', 'USD');
define('WPMT_CURRENCY_SYMBOL', '$');


if(isset($wpdb->prefix))
{
	define('WPMT_DB_PREFIX',$WPMT_DATABASE_PREFIX_OVERRIDE);										
}
else
{
	define('WPMT_DB_PREFIX','get_the_table_prefix');
}

//Hook into install and uninstall
include_once dirname( __FILE__ ).'/includes/wpmt_tables.php';
register_activation_hook(__FILE__,'wpmt_install');
register_deactivation_hook(__FILE__,'wpmt_uninstall');
add_action( 'admin_menu', 'wpmt_create_menu' );


//Add Javascript	
add_action('admin_enqueue_scripts', 'wpmt_load_scripts');
add_action('wp_enqueue_scripts','wpmt_load_frontend_scripts');


//Don't change this unless you know exactly what you're doing
define('WPMT_PLUGIN_DIRECTORY', 'wpmt');


//STYLE UP THE PAGE
add_action('admin_head', 'wpmt_admin_head');


//START THE APPLICATION WOOHOO!
include_once dirname( __FILE__ ).'/includes/wpmt_apptop.php';
add_action('wp_loaded','wpmt_apptop');


//Javascript user enqueuer
function wpmt_load_frontend_scripts() {

if ( !is_admin() && $_GET['wpmt_viewing']!=1 )  {
	//jQuery		
	wp_enqueue_script('jquery');
	
	//Ajax
	wp_enqueue_script('wpmt-ajax', plugin_dir_url(__FILE__) . 'admin_pages/ajax/wpmt_ajax_handler.js', array('jquery'));
	wp_enqueue_script('wpmt-ajax-tracker', plugin_dir_url(__FILE__) . 'admin_pages/ajax/wpmt_tracker.js', array('jquery'));
	wp_localize_script('wpmt-ajax', 'wpmt_vars', array(
			'wpmt_nonce' => wp_create_nonce('wpmt-nonce')
		)
	);
	
}
		
}

//Javascript admin enqueuer
function wpmt_load_scripts() {

	if($_GET['wpmt_viewing']!=1) {

	//jQuery		
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-datepicker');
	wp_enqueue_script('jquery-ui-slider');
	wp_enqueue_script('jquery-ui-resizable');
		
	//Flot Graph
	wp_enqueue_script('jquery-flot', plugin_dir_url(__FILE__) . 'admin_pages/jquery/graph/jquery.flot.js', array('jquery'));
	wp_enqueue_script('jquery-flot.resize', plugin_dir_url(__FILE__) . 'admin_pages/jquery/graph/jquery.flot.resize.js', array('jquery'));
	wp_enqueue_script('jquery-flot.selection', plugin_dir_url(__FILE__) . 'admin_pages/jquery/graph/jquery.flot.selection.js', array('jquery'));
	wp_enqueue_script('jquery-flot.orderBars', plugin_dir_url(__FILE__) . 'admin_pages/jquery/graph/jquery.flot.orderBars.js', array('jquery'));
	
	//jQuery
	wp_enqueue_script('jcanvas', plugin_dir_url(__FILE__) . 'admin_pages/jquery/jcanvas.js', array('jquery'));
			
	//Ajax
	wp_enqueue_script('wpmt-ajax', plugin_dir_url(__FILE__) . 'admin_pages/ajax/wpmt_ajax_handler.js', array('jquery'));
	wp_localize_script('wpmt-ajax', 'wpmt_vars', array(
			'wpmt_nonce' => wp_create_nonce('wpmt-nonce')
		)
	);
	
	}
	
}



//Creates menu items for the plugin
function wpmt_create_menu() {
	
//add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );

$user = wp_get_current_user();
if ( $user->roles[0]!='subscriber' ) {
		
	add_menu_page( 

	__('Don\'s WP RMT Dashboard', EMU2_I18N_DOMAIN),

	__('Don\'s WP RMT', EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	'',

	plugins_url('/images/icon.png', __FILE__));

	
	add_submenu_page( 

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	__("Don's WP RMT Real Time Visitor Spy", EMU2_I18N_DOMAIN),

	__("Real Time Spy", EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_real_time.php'

	);
	
	
	add_submenu_page( 

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	__("Don's WP RMT View Multiple Recordings", EMU2_I18N_DOMAIN),

	__("Multi Recordings", EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_multi.php'

	);
	
	
	add_submenu_page( 

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	__("Don's WP RMT View Single Recording", EMU2_I18N_DOMAIN),

	__("Single Recordings", EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_single.php'

	);


	add_submenu_page( 

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	__("Don's WP RMT Visitor Log", EMU2_I18N_DOMAIN),

	__("Visitor Log", EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_tracking.php'

	);
	

	add_submenu_page( 

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	__("Don's WP RMT Visitor Filtering", EMU2_I18N_DOMAIN),

	__("Filtering", EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_filter.php'

	);
	

	
	add_submenu_page( 

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_index.php',

	__("Don's WP RMT Settings", EMU2_I18N_DOMAIN),

	__("Settings", EMU2_I18N_DOMAIN),

	0,

	WPMT_PLUGIN_DIRECTORY.'/admin_pages/wpmt_settings.php'

	);



}
	
}


add_action( 'wp_ajax_wpmt_realtime_visitor_table', 'wpmt_realtime_visitor_table' );
add_action( 'wp_ajax_nopriv_wprdt', 'wprdt' );
add_action( 'wp_ajax_wpmt_wprdt', 'wprdt' );
add_action( 'wp_ajax_wpmt_load_recording', 'wpmt_load_recording' );
add_action('wp_head', 'wpmt_set_js_variables');

add_action('shutdown','wpmt_log_page_load_time');

//Admin Head
function wpmt_admin_head() {  

if($_GET['wpmt_viewing']!=1) {
	
echo '<link rel="stylesheet" type="text/css" href="' .plugins_url('wpmt_admin.css', __FILE__). '">'; 
echo '<link rel="stylesheet" type="text/css" href="' .plugins_url('admin_pages/jquery/date_picker/css/redmond/jquery-ui.css', __FILE__). '">';

}


}


?>